#define CREATE 0
#define OPEN 1
#define CLOSE 2
#define ADD 3
#define READ 4
#define PURGE 5
#define APPEND 6
#define HASH_READ 7
#define DELETE 8
#define UNDELETE 9
#define STICKY_BIT       0x0001
#define EXPORTED_BIT     0x0002
#define QWK_NETWORK_BIT  0x0004
#define REGISTER register int
#define MAX_CALLER 0x7FFFFFFFL
#define MAX_PID 32

typedef unsigned long LONGINTEGER;
typedef unsigned char BOOLEAN;
typedef unsigned char STRING;
typedef unsigned char BYTE;
typedef unsigned int  INTEGER;

extern void _fastcall ccitt_crc_calc(unsigned);
extern void _fastcall ccitt_crc32_calc(unsigned);

struct old13_user_record {
    char      old13_user_deleted;
    STRING    old13_user_name[31];
    int       old13_user_msg_number;
    STRING    old13_user_date[9];
    int       old13_user_credit;
    STRING    old13_user_time[9];
    int       old13_user_charges;
    int       old13_user_times_on;
    char      old13_user_banned;
    char      old13_user_expert;
    char      old13_user_more;
    STRING    old13_user_home[31];
    STRING    old13_user_password[21];
    STRING    old13_user_phone[11];
    char      old13_user_privel;
    char      old13_user_day_calls;
    int       old13_user_accum_time;
};

typedef struct idx_record {
    BOOLEAN   hash_del_flg;
    BOOLEAN   hash_re_used;
    INTEGER   hash_code;
    INTEGER   hash_ptr;
} IDX_RECORD;

typedef struct old_user_record {                       /*  OFFSETS  */
    BOOLEAN      old_user_deleted;                     /*      0    */
    STRING       old_user_name[31];                    /*      1    */
    STRING       old_user_first_date[9];               /*     32    */
    STRING       old_user_first_time[6];               /*     41    */
    STRING       old_user_last_date[9];                /*     47    */
    STRING       old_user_last_time[6];                /*     56    */
    INTEGER      old_user_credit;                      /*     62    */
    INTEGER      old_user_charges;                     /*     64    */
    INTEGER      old_user_times_on;                    /*     66    */
    BOOLEAN      old_user_banned;                      /*     68    */
    BOOLEAN      old_user_expert;                      /*     69    */
    BOOLEAN      old_user_more;                        /*     70    */
    STRING       old_user_home[31];                    /*     71    */
    STRING       old_user_phone[11];                   /*    102    */
    STRING       old_user_password[21];                /*    113    */
    char         old_user_privel;                      /*    134    */
    INTEGER      old_user_day_calls;                   /*    135    */
    INTEGER      old_user_accum_time;                  /*    137    */
    char         old_user_protocol;                    /*    139    */
    INTEGER      old_user_screen_lgth;                 /*    140    */
    INTEGER      old_user_upload_k;                    /*    142    */
    INTEGER      old_user_upload_files;                /*    144    */
    INTEGER      old_user_dnload_k;                    /*    146    */
    INTEGER      old_user_dnload_files;                /*    148    */
    LONGINTEGER  old_user_caller_no;                   /*    150    */
    INTEGER      old_user_hash_code;                   /*    154    */
    STRING       old_user_cb_handle[10];               /*    156    */
    INTEGER      old_user_expire_date;                 /*    166    */
    int          old_user_time_bank;                   /*    168    */
    INTEGER      old_user_day_dnload_k;                /*    170    */
    int          old_user_day_time_deposits;           /*    172    */
    int          old_user_day_time_withdrawals;        /*    174    */
} OLD_USER_RECORD;

typedef struct user_record {
    BOOLEAN      user_deleted;
    STRING       user_name[31];
    STRING       nf_first_date[9];
    STRING       user_first_time[6];
    STRING       nf_last_date[9];
    STRING       user_last_time[6];
    LONGINTEGER  user_netmail_credits;
    LONGINTEGER  user_netmail_charges;
    BOOLEAN      user_banned;
    BOOLEAN      user_expert;
    BOOLEAN      user_more;
    STRING       user_street_addr[31];
    STRING       user_city_state_zip[31];
    STRING       nf_phone[21];
    STRING       user_password[21];
    LONGINTEGER  nf_privel;
    char         user_protocol;
    INTEGER      user_screen_lgth;
    LONGINTEGER  user_caller_no;
    LONGINTEGER  user_hash_code;
    STRING       user_cb_handle[10];
    STRING       nf_expire_date[9];
    LONGINTEGER  user_expired_privel;

    LONGINTEGER  user_total_calls;
    LONGINTEGER  user_total_connect_time;
    LONGINTEGER  user_total_connect_time_peak;
    LONGINTEGER  user_total_connect_time_offpeak;
    LONGINTEGER  user_total_upload_k;
    INTEGER      user_total_upload_files;
    LONGINTEGER  user_total_dnload_k;
    INTEGER      user_total_dnload_files;
    long         user_total_time_bank;

    INTEGER      user_day_calls;
    INTEGER      user_day_connect_time;
    INTEGER      user_day_connect_time_peak;
    INTEGER      user_day_connect_time_offpeak;
    LONGINTEGER  user_day_upload_k;
    INTEGER      user_day_upload_files;
    LONGINTEGER  user_day_dnload_k;
    INTEGER      user_day_dnload_files;
    int          user_day_time_deposits;
    int          user_day_time_withdrawals;

    INTEGER      user_week_calls;
    INTEGER      user_week_connect_time;
    INTEGER      user_week_connect_time_peak;
    INTEGER      user_week_connect_time_offpeak;
    LONGINTEGER  user_week_upload_k;
    INTEGER      user_week_upload_files;
    LONGINTEGER  user_week_dnload_k;
    INTEGER      user_week_dnload_files;
    int          user_week_time_deposits;
    int          user_week_time_withdrawals;

    INTEGER      user_month_calls;
    INTEGER      user_month_connect_time;
    INTEGER      user_month_connect_time_peak;
    INTEGER      user_month_connect_time_offpeak;
    LONGINTEGER  user_month_upload_k;
    INTEGER      user_month_upload_files;
    LONGINTEGER  user_month_dnload_k;
    INTEGER      user_month_dnload_files;
    long         user_month_time_deposits;
    long         user_month_time_withdrawals;

    INTEGER      user_year_calls;
    LONGINTEGER  user_year_connect_time;
    LONGINTEGER  user_year_connect_time_peak;
    LONGINTEGER  user_year_connect_time_offpeak;
    LONGINTEGER  user_year_upload_k;
    INTEGER      user_year_upload_files;
    LONGINTEGER  user_year_dnload_k;
    INTEGER      user_year_dnload_files;
    long         user_year_time_deposits;
    long         user_year_time_withdrawals;

    INTEGER      user_qwk_max_msgs_conf;
    INTEGER      user_qwk_max_conf_pkt;
    INTEGER      user_qwk_max_conf_total;
    INTEGER      user_qwk_max_msgs;
    INTEGER      user_qwk_max_sectors;
    BOOLEAN      user_qwk_7bit_code;

    STRING       user_birth_date[9];
    BOOLEAN      user_birth_date_verified;
    INTEGER      user_msgs_bitmask;
    INTEGER      user_files_bitmask;
    STRING       user_mailbox_name[12];
    STRING       user_msgs_handle[31];
    BOOLEAN      user_force_quest0;
    STRING       user_sysop_comment[31];
    BOOLEAN      user_sysop_bool1;
    BOOLEAN      user_sysop_bool2;
    char         user_sysop_char1;
    char         user_sysop_char2;
    long         user_sysop_long1;
    long         user_sysop_long2;

    LONGINTEGER  user_total_msgs_stored;
    LONGINTEGER  user_total_msgs_read;
    long         user_dollar_balance;
    long         user_dollar_credit;
    long         user_dollar_debit;
    char         user_clear_screen;

    char         user_filler[22];
} USER_RECORD;

struct msg_record {
    BOOLEAN        msg_deleted;
    INTEGER        msg_number;
    STRING         msg_sender[31];
    STRING         msg_addressee[31];
    STRING         msg_topic[31];
    STRING         msg_date[9];
    int            msg_dest_net;
    STRING         msg_time[6];
    BYTE           msg_weekday;
    BYTE           msg_flags;          //   0x01 - STICKY BIT
				       //   0x02 - EXPORTED BIT
				       //   0x04 - QWK NETWORK BIT
                                       //   0x08 - MAILBOX BIT
    char           msg_filler;
    int            msg_dest_node;
    BYTE           msg_perm_priv;
    BYTE           msg_received;
    INTEGER        msg_reply_no[3];
    INTEGER        msg_orig_no;
};

typedef struct {
    BOOLEAN        user_msg_deleted;
    INTEGER        user_msg_prior_read;
    INTEGER        user_msg_highest_scan;
    LONGINTEGER    user_msg_caller_no;
    INTEGER        user_msg_hash_code;
    BOOLEAN        user_msg_banned;
    INTEGER        user_msg_marked[2];
} USER_MSG_RECORD;

typedef struct {                              /*       Active Flag        */
    INTEGER        pid_active;                /*                          */
    STRING         pid_name[20];              /*   0 = Inactive           */
    STRING         pid_program[14];           /*   1 = Waiting for call   */
    STRING         pid_function[32];          /*   2 = Caller Online      */
    STRING         pid_callername[32];        /*   3 = Terminal Mode      */
    STRING         pid_curr_msg_path[64];
    STRING         pid_curr_file_path[64];
    BYTE           pid_xnumber;
    BOOLEAN        pid_xmessage_ready;
    STRING         pid_xmessage[80];
    char           pid_cb_handle[10];
    char           pid_filler[64];
} PID_RECORD;

typedef struct {
    int                  dram_status;          /*  0=Closed,  1=Open  */
    int                  record_locking;       /*  0=No Lock, 1=Lock  */
    int                  dat_handle;
    LONGINTEGER          datfpos;
    int                  dat_lock_active;
    LONGINTEGER          dat_lock_offset;
    LONGINTEGER          dat_lock_lgth;
    int                  idx_handle;
    LONGINTEGER          idxfpos;
    int                  idx_lock_active;
    LONGINTEGER          idx_lock_offset;
    LONGINTEGER          idx_lock_lgth;
    long                 dat_recsize;
    int                  dat_keypos;
    int                  dat_keytype;
    STRING               string_key[80];          /*    Type 0,2   */
    LONGINTEGER          binary_key;              /*    Type 1     */
    INTEGER              hash_key;
    STRING               dram_path[80];
    STRING               dram_fname[16];
    USER_RECORD          *user_rec;               /*    Type 0 & 2   */
    USER_MSG_RECORD      *user_msg_rec;           /*    Type 1       */
    IDX_RECORD           *idx_rec;
} DRAM;

typedef struct {
    BOOLEAN   files_deleted;
    STRING    files_name[31];
    STRING    files_path[61];
    long      files_size;
    char      files_month;
    char      files_day;
    int       files_year;
    BYTE      files_privel[8];
    BOOLEAN   files_offline;
    BOOLEAN   files_cdrom;
    BOOLEAN   files_free_area;
    unsigned char files_no_dnload_area_privel;
} FILES_RECORD;

int dram(int,DRAM *);
int dram_create(DRAM *,int);
int dram_open(DRAM *,int);
int dram_read(DRAM *,int);
int dram_add(DRAM *,int);
int dram_close(DRAM *,int);
int dram_delete(DRAM *,int);
int dram_undelete(DRAM *,int);
void idx_expand(DRAM *);
int re_org(DRAM *,int);
void backup_idx(DRAM *);
int fexist(STRING *);
int dexist(STRING *);
DRAM *allocate_fcb(void);
void release_fcb(DRAM *);
void lock_dat(DRAM *,LONGINTEGER,LONGINTEGER);
void lock_idx(DRAM *,LONGINTEGER,LONGINTEGER);
void unlock_dat(DRAM *);
void unlock_idx(DRAM *);
long readfile(int,char*,unsigned long);
long writefile(int,char*,unsigned long);
int seekfile(int,LONGINTEGER,int);
int o_mode(int);
int createfile(char *);
int closefile(int,char *);
void prt_error(char *,char *);
LONGINTEGER elapsed(LONGINTEGER);
void real_time(LONGINTEGER *);
void dram_slasher(DRAM *);
void lock_g(int,LONGINTEGER,LONGINTEGER);
void unlock_g(int,LONGINTEGER,LONGINTEGER);

extern STRING   copyright1[];
extern STRING   copyright2[];
extern INTEGER  begin_prime;
extern INTEGER  prime[];
extern INTEGER  crc_reg_lo;
extern INTEGER  crc_reg_hi;
